
//Wireshark!
//(ip.src == 192.168.12.220 and ip.dst == 192.168.12.8) or ( ip.dst == 192.168.12.220 )

#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include <fcntl.h>
#include <sys/stat.h>

#define BUFLEN 512

void diep(char *s)
{
  perror(s);
  exit(1);
}

int main(int argc, char *argv[])
{
  struct sockaddr_in si_me;
  int s;
  char buf[BUFLEN];
  char label[BUFLEN];
  int antwort;
  int i;
  int laenge;

  //Pruefen ob User doof
  if ((argc<2) || (argc>3)) {
    printf("\nrtblabel <channel> <label max8>\n\n");
    diep("Argument error!");
  }
     

  //TCP-Socket zum Oszi aufmachen 
  if ((s=socket(AF_INET, SOCK_STREAM, 0))==-1)  diep("kein socket");
  memset((char *) &si_me, 0, sizeof(si_me));
  si_me.sin_family = AF_INET;
  si_me.sin_port = htons(5025); //Port für SCPI-Kommando über TCP
  inet_aton("192.168.12.220", (struct in_addr *) &si_me.sin_addr.s_addr );
  if ( connect(s,(struct sockaddr *) &si_me , sizeof(si_me))==-1) diep("kein connect");

  sscanf(argv[1],"%i",&i);

  if (argc==3)
    {
      sscanf(argv[2],"%s",label);
      *(label+8)=0;
 
      switch(i)
	{
	case 1: 
	  printf("Set CH1 to: %s\n",label); 
	  sprintf(buf,"CHAN1:LAB:STAT ON\n",label);  
	  write(s,buf,strlen(buf));
	  sprintf(buf,"CHAN1:LAB \"%s\"\n",label);  
	  break;

	case 2: 
	  printf("Set CH2 to: %s\n",label); 
	  sprintf(buf,"CHAN2:LAB:STAT ON\n",label);  
	  write(s,buf,strlen(buf));
	  sprintf(buf,"CHAN2:LAB \"%s\"\n",label);  
	  break;

	case 3: 
	  printf("Set CH3 to: %s\n",label); 
	  sprintf(buf,"CHAN3:LAB:STAT ON\n",label);  
	  write(s,buf,strlen(buf));
	  sprintf(buf,"CHAN3:LAB \"%s\"\n",label);  
	  break;

	case 4: 
	  printf("Set CH4 to: %s\n",label); 
	  sprintf(buf,"CHAN4:LAB:STAT ON\n",label);  
	  write(s,buf,strlen(buf));
	  sprintf(buf,"CHAN4:LAB \"%s\"\n",label);  
	  break;

	default: diep("unknown channel");

	}
    }

  if (argc==2)
    {
      switch(i)
	{

	case 1: 
	  printf("Set CH1 label off\n"); 
	  sprintf(buf,"CHAN1:LAB:STAT OFF\n",label);  
	  break;

	case 2: 
	  printf("Set CH2 label off\n"); 
	  sprintf(buf,"CHAN2:LAB:STAT OFF\n",label);  
	  break;

	case 3: 
	  printf("Set CH3 label off\n"); 
	  sprintf(buf,"CHAN3:LAB:STAT OFF\n",label);  
	  break;

	case 4: 
	  printf("Set CH4 label off\n"); 
	  sprintf(buf,"CHAN4:LAB:STAT OFF\n",label);  
	  break;

	default: diep("unknown channel");
	}
    }

  //Kommando erzeugen und absenden
  //   sprintf(buf,"*IDN?\n"); 
  //sprintf(buf,"DVM1:ENAB ON\n");  //Digitalmultimeter  einschalten
  //sprintf(buf,"CHAN1:LAB \"Dada\"\n");  
  write(s,buf,strlen(buf));
  
  close(s);


  return 0;
}
